from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from StringIO import StringIO
from Products.PloneSVNaccess.config import PROJECTNAME, GLOBALS, view_role, write_role, webdav_role
from Products.PloneSVNaccess.PloneSVNaccessWorkflow import svnWf
from Products.CMFCore.WorkflowTool import addWorkflowFactory, _makeWorkflowFactoryKey

##
# Install PloneSVNaccess<br>
#<br>
# Install skin<br>
# Add the new Roles <br>
# Install PloneSVNaccessWorkflow<br>
# Install PloneSVNaccessTool<br>
# Add PloneSVNaccessVersioning to Member Data 

def install(self):
	out = StringIO()

	installTypes(self, out,
		listTypes(PROJECTNAME),
		PROJECTNAME)
	
	#
	# Install skin
	#
	try:
		install_subskin(self, out, GLOBALS)
	except:
		print >> out, "Subskin added"
	else:
		print >> out, "Error: Error adding subskin"

	#
	# Add the new Roles 
	#
	addUserDefinedRole(self, view_role, out)
	addUserDefinedRole(self, write_role, out)
	addUserDefinedRole(self, webdav_role, out)

	#
	# Install PloneSVNaccessWorkflow
	#
	addWorkflowFactory(svnWf, id='PloneSVNaccessWorkflow', title='PloneSVNaccessWorkflow')

	wtool = self.portal_workflow
		
	if "PloneSVNaccessWorkflow" in wtool.objectIds():
		wtool._delObject("PloneSVNaccessWorkflow")
	
	workflow_type=_makeWorkflowFactoryKey(svnWf, id="PloneSVNaccessWorkflow", title="PloneSVNaccessWorkflow")  
	wtool.manage_addWorkflow(workflow_type, "PloneSVNaccessWorkflow")
	
	wtool.updateRoleMappings()
	
	wtool.setChainForPortalTypes((PROJECTNAME,), "PloneSVNaccessWorkflow")
	
	
	#
	# Install PloneSVNaccessTool
	#
	if not hasattr(self, 'PloneSVNaccessTool'):
		addTool = self.manage_addProduct['PloneSVNaccess'].manage_addTool
		# Add the tool by its meta_type
		try:
			addTool('Plone SVN access Tool')
		except:
			print >> out, "PloneSVNaccessTool installed"
		else:
			print >> out, "Error: Error installing PloneSVNaccessTool"
		

	#
	# Add PloneSVNaccessVersioning to Member Data 
	#
	try:
		self.portal_memberdata.manage_addProperty('PloneSVNaccessVersioning', {}, 'tokens')
	except:
		print >> out, "Warning: Can not add PloneSVNaccessVersioning to Member Data. Check ZMI > Plone > portal_memberdata > Properties if PloneSVNaccessVersioning is installed. (Ignore if you do not install PloneSVNaccess the first time)"
	else:
		print >> out, "Info: PloneSVNaccessVersioning added to Member Data"

	#
	# Print install info
	#
	print >> out, "Successfully installed %s." % PROJECTNAME
	return out.getvalue()
	

##
# Add the role 'role' to the plone root<br>
# http://www.zope.org/Wikis/DevSite/Proposals/ExistingUserAndRoleAPIs
#
def addUserDefinedRole(self, role, out):
	"""
		Add the role 'role' to the plone root
	"""
	if not self._has_user_defined_role(role):
		self._addRole(role)
		print >> out, "Role " + role + " added!"


